<template>
    <div class="app-container">
      <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch">
        <el-form-item label="会议室名称" prop="groomName">
          <el-input v-model="queryParams.groomName" placeholder="请输入会议室名称" clearable @keyup.enter.native="handleQuery"/>
        </el-form-item>
        <el-form-item>
          <el-button type="primary" icon="el-icon-search" @click="handleQuery">搜索</el-button>
          <el-button icon="el-icon-refresh" @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>
  
      <el-row :gutter="10" class="mb8">
        <el-col :span="1.5">
          <el-button type="primary" plain icon="el-icon-plus" size="mini" @click="handleAdd"
                     v-hasPermi="['meeting:list:create']">新增</el-button>
        </el-col>
        <!-- <el-col :span="1.5">
          <el-button type="warning" icon="el-icon-download" size="mini" @click="handleExport" :loading="exportLoading"
                     v-hasPermi="['system:post:export']">导出</el-button>
        </el-col> -->
        <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
      </el-row>
  
      <el-table v-loading="loading" :data="postList">
        <el-table-column label="会议室名称" align="center" prop="groomName" />
        <el-table-column label="容纳人数" align="center" prop="groomSize" />
        <el-table-column label="管理员" align="center" prop="administratorName" />
        <el-table-column label="添加时间" align="center" prop="createTime" width="180">
          <template v-slot="scope">
            <span>{{ parseTime(scope.row.createTime) }}</span>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template v-slot="scope">
            <el-button size="mini" type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)"
                       v-hasPermi="['meeting:list:update']">修改</el-button>
            <el-button size="mini" type="text" icon="el-icon-delete" @click="handleDelete(scope.row)"
                       v-hasPermi="['meeting:list:delete']">删除</el-button>
          </template>
        </el-table-column>
      </el-table>
  
      <pagination v-show="total>0" :total="total" :page.sync="queryParams.pageNo" :limit.sync="queryParams.pageSize"
                  @pagination="getList"/>
  
      <!-- 添加或修改岗位对话框 -->
      <el-dialog :title="title" :visible.sync="open" width="800px" append-to-body>
        <el-form ref="form" :model="form" :rules="rules" label-width="80px">
          <el-form-item label="名称" prop="groomName">
            <el-input v-model="form.groomName" placeholder="请输入会议室名称" />
          </el-form-item>
          <el-form-item label="容纳人数" prop="groomSize">
            <el-input-number v-model="form.groomSize" controls-position="right" :min="0" />
            
          </el-form-item>
          <el-form-item label="管理员" prop="administratorName">
            <el-input v-model="form.administratorName" placeholder="请选择管理员" readonly @click.native="openSingle" />
          </el-form-item>
        </el-form>
        <div slot="footer" class="dialog-footer">
          <el-button type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </el-dialog>
      <PeopleSelect ref="peopleSelect" type="single" :isCheck="true" :open="singlePeopleOpen" @cancel="singlePeopleOpen = false"
      @submit="submitSingle"></PeopleSelect>
    </div>
  </template>
  
  <script>
  import { listPost, getPost, delPost, addPost, updatePost, exportPost } from "@/api/meeting";
  import PeopleSelect from "@/components/PeopleSelect/index.vue";
  import {CommonStatusEnum} from '@/utils/constants'
  import { getDictDatas, DICT_TYPE } from '@/utils/dict'
  
  export default {
    name: "SystemPost",
    components: {
    PeopleSelect,
  },
    data() {
      return {
        singlePeopleOpen: false,
        // 遮罩层
        loading: true,
        // 导出遮罩层
        exportLoading: false,
        // 显示搜索条件
        showSearch: true,
        // 总条数
        total: 0,
        // 岗位表格数据
        postList: [],
        // 弹出层标题
        title: "",
        // 是否显示弹出层
        open: false,
        // 查询参数
        queryParams: {
          pageNo: 1,
          pageSize: 10,
          groomName: undefined,
        },
        // 表单参数
        form: {},
        // 表单校验
        rules: {
          groomName: [
            { required: true, message: "会议室名称不能为空", trigger: "blur" }
          ],
          groomSize: [
            { required: true, message: "容纳人数不能为空", trigger: "blur" }
          ],
          administratorName: [
            { required: true, message: "管理员不能为空", trigger: "blur" }
          ]
        },
  
        // 枚举
        CommonStatusEnum: CommonStatusEnum,
        // 数据字典
        statusDictDatas: getDictDatas(DICT_TYPE.COMMON_STATUS)
      };
    },
    created() {
      this.getList();
    },
    methods: {
       //打开选人弹窗
   openSingle() {
      this.singlePeopleOpen = true;
    },
    submitSingle(peopleList,nikeNamelist,userIdList) {
      console.log(peopleList);
      console.log(nikeNamelist);
      this.form.administratorId = userIdList.join();
      this.form.administratorName = nikeNamelist.join();
      this.singlePeopleOpen = false;
    },
      /** 查询岗位列表 */
      getList() {
        this.loading = true;
        listPost(this.queryParams).then(response => {
          this.postList = response.data.list;
          this.total = response.data.total;
          this.loading = false;
        });
      },
      // 取消按钮
      cancel() {
        this.open = false;
        this.reset();
      },
      // 表单重置
      reset() {
        this.form = {
          groomName: undefined,
          groomSize: 0,
          administratorName: undefined,
          administratorId: undefined
        };
        this.resetForm("form");
      },
      /** 搜索按钮操作 */
      handleQuery() {
        this.queryParams.pageNo = 1;
        this.getList();
      },
      /** 重置按钮操作 */
      resetQuery() {
        this.resetForm("queryForm");
        this.handleQuery();
      },
      /** 新增按钮操作 */
      handleAdd() {
        this.reset();
        this.open = true;
        this.title = "添加会议室";
      },
      /** 修改按钮操作 */
      handleUpdate(row) {
        this.reset();
        const id = row.id
        getPost(id).then(response => {
          this.form = response.data;
          this.open = true;
          this.title = "修改会议室";
        });
      },
      /** 提交按钮 */
      submitForm: function() {
        this.$refs["form"].validate(valid => {
          if (valid) {
            if (this.form.id !== undefined) {
              updatePost(this.form).then(response => {
                this.$modal.msgSuccess("修改成功");
                this.open = false;
                this.getList();
              });
            } else {
              addPost(this.form).then(response => {
                this.$modal.msgSuccess("新增成功");
                this.open = false;
                this.getList();
              });
            }
          }
        });
      },
      /** 删除按钮操作 */
      handleDelete(row) {
        const ids = row.id;
        this.$modal.confirm('是否确认删除会议室编号为"' + ids + '"的数据项?').then(function() {
            return delPost(ids);
          }).then(() => {
            this.getList();
            this.$modal.msgSuccess("删除成功");
        }).catch(() => {});
      },
      /** 导出按钮操作 */
      handleExport() {
        const queryParams = this.queryParams;
        this.$modal.confirm('是否确认导出所有会议室数据项?').then(() => {
            this.exportLoading = true;
            return exportPost(queryParams);
          }).then(response => {
            this.$download.excel(response, '会议室数据.xls');
            this.exportLoading = false;
        }).catch(() => {});
      }
    }
  };
  </script>
  